<?php 
/***************************************************************************
*   2001/09 Ph Ripond
*
*   FONCTIONS DIVERSES
*/
/**************************************************************************/
function nul() {}

/********************************************************************************
*  Preparation variable saisie pour stockage base de donne
*   - Escape des caractres spciaux selon la valeur de get_magic_quotes_gpc
********************************************************************************/
function stripslashes_deep($value){

    $value = is_array($value) ?

                array_map('stripslashes_deep', $value) :

                stripslashes($value);


    return $value;

}

function escape( $str )
{
	
  //!get_magic_quotes_gpc() ? $str = addslashes($str) : nul() ;  
	if((function_exists("get_magic_quotes_gpc") && get_magic_quotes_gpc())    || (ini_get('magic_quotes_sybase') && (strtolower(ini_get('magic_quotes_sybase'))!="off")) ){

		stripslashes_deep($str);

	}
	
  $str = (isset($str) && $str!="") ? htmlentities(mb_convert_encoding(trim($str), 'UTF-8', 'ISO-8859-1')) : '' ;  ///$str = htmlspecialchars(trim($str)) ;
  $str = str_replace("&amp;" , "&", $str ) ;
  return $str;
}
/********************************************************************************
*  Preparation variable stocke base de donne
*   - Unescape des caractres spciaux selon la valeur de get_magic_quotes_gpc
********************************************************************************/
function unEscape( $str )
{
  	//!get_magic_quotes_gpc() ? $str = stripslashes($str) : nul() ;
  	if((function_exists("get_magic_quotes_gpc") && get_magic_quotes_gpc())    || (ini_get('magic_quotes_sybase') && (strtolower(ini_get('magic_quotes_sybase'))!="off")) ){

		stripslashes_deep($str);

	}

	// reconversion caratres echaps par htmlspecialchars()  ( Cf aide php pour precisions )
  $trans = get_html_translation_table(HTML_ENTITIES);
  $trans = array_flip($trans);
  $str = strtr($str, $trans);

  return $str;
}
/********************************************************************************
*  Preparation variable lue dans une table pour stockage directement dans une table
*   - Escape des caractres spciaux selon la valeur de get_magic_quotes_runtime
********************************************************************************/
function escapeRuntime( $str )
{
  //!get_magic_quotes_runtime() ? $str = addslashes($str) : nul() ;
	$str = addslashes($str ?? '');
  return $str;
}
/****************************************************************************
 *    function: isOkEmail
 *  created by: Gregory Day
 * description: Validates an e-mail address.  Only checks that the format
 *              is valid.  It does not validate that the address will
 *              work.
 *  parameters: $email: Email address to validate
 *     returns: true: Email address is valid
 *              false: Email address is not valid
 ****************************************************************************/
function isOkEmail ( $email ) {	
	//if(ereg('^[_a-z0-9A-Z-]+(\.[_a-z0-9A-Z-]+)*@[a-z0-9A-Z-]+(\.[a-z0-9A-Z-]+)*$', $email)) 
	if(preg_match('/^[_a-z0-9A-Z-]+(\.[_a-z0-9A-Z-]+)*@[a-z0-9A-Z-]+(\.[a-z0-9A-Z-]+)*$/', $email)){
		return(true);
   	}
   	else {
		return(false);
   	}
}

/********************************************************************************
*  Contrle si les champs passs dans le tableau ont t saisis ou sont vides
*    $p[] : valeur du champ a tester
*    $t[] : texte a afficher en cas d'erreur
********************************************************************************/
function champs_Oblig( $p=array() , $t=array() )
{
    // controle des champs
    $mesretour = "" ;
	if(!empty($p)){
		for ( $i=0 ; $i < count($p) ; $i++ )
		{
		  if ( trim($p[$i]) == "")
			{
			 $mesretour.= "<b>Champ ".$t[$i]." obligatoire</b><br>";
			}
		}
	}
    return ($mesretour) ;
}

/********************************************************************************
*  Test la longueur des champs saisis
*    $p[] : valeur du champ a tester
*    $t[] : texte a afficher en cas d'erreur
*    $l[] : longuer max du champ
********************************************************************************/
function test_Long( $p, $t, $l )
{
    global $mesretour;
    for ( $i=0 ; $i<count($p) ; $i++ )
        {
          if ( strlen($p[$i]) > $l[$i] )
            {
             $mesretour.= "- Champ ".$t[$i]." trop long<br>";
            }
        }
}

/********************************************************************************
*   Test de la validite d'une date saisie avec le format :
*       jj/mm/aa
*       le caractre de sparation peut-etre l'espace ou / ou -
*       les valeurs doivent abligatoirerment avoir 2 chiffres
*   Renvoie false si invalide
*   Renvoie la date en timestamp si valide
********************************************************************************/
/* ANCIENNE FONCTION PEMPLACEE PAR LA SUIVANTE SUITE MODIF FORMAT DES CHAMPS DATE
   de varchar (timesstamp) en DATETIME

function isOkDate($date, $h="" , $m="" , $s="" )
{
  if ( !ereg( "^([0-9]{2})[ ./\-]([0-9]{2})[ ./\-]([0-9]{2,4})$" , $date, $tab) ) {
        return false;
  }
  //if ( intval($tab[3]) == 0 ) { $tab[3] = "2000" ; }
  if ( !checkdate ( intval($tab[2]) , intval($tab[1]) , intval($tab[3]) ) )   {
        return false ;
  }

//  L'enregistrement en GMT est absolument inutile car les dates et heures saisies sont "absolues", ie qu'elles ne
//  dpendent pas de l'endroit ou on est.
//  ex : si arrive 15h00, c'est 15h00 pour la Martinique, donc c'est ce qui doit tre stock.
//  Le but tait de pouvoir rcuprer les donnes et fonctionner en local sur le serveur dans un autre fuseau horaire.
//  Le fait d'utiliser GMT ne permet pas de rcuprer la date souhaite car le dcalage a appliquer n'est pas celui
//  du serveur de fonctionnement mais celui d'origine...

 return ( gmmktime($h,$m,$s,$tab[2],$tab[1],$tab[3]) )  ;// original
//  return ( mktime($h,$m,$s,$tab[2],$tab[1],$tab[3]) )  ;
}
*/
/********************************************************************************
*   Test de la validite d'une date saisie avec le format :
*       jj/mm/aa
*       le caractre de sparation peut-etre l'espace ou / ou -
*       les valeurs doivent abligatoirerment avoir 2 chiffres
*   Renvoie false si invalide
*   Renvoie la date en format mysql si valide (yyyy-mm-jj hh:mm:ss)
********************************************************************************/
function isOkDate($date, $h="00" , $m="00")
{
	//if ( !ereg( "^([0-9]{2})[ ./\-]([0-9]{2})[ ./\-]([0-9]{2,4})$" , $date, $tab) ) 
 	if ( !preg_match( '/^([0-9]{2})[.\/-]([0-9]{2})[.\/-]([0-9]{2,4})$/' , $date, $tab) ) {
        return false;
  	}
  if ( intval($tab[3]) == 0 ) { $tab[3] = "2000" ; }
  if ( !checkdate ( intval($tab[2]) , intval($tab[1]) , intval($tab[3]) ) )   {
        return false ;
  }
  return ( "20".$tab[3]."-".$tab[2]."-".$tab[1]." $h:$m:00 " )  ;
}


/********************************************************************************
*   Test de la validite d'une date saisie avec le format :
*       jj/mm/aaaa
*       le caractre de sparation peut-etre l'espace ou / ou -
*       les valeurs doivent abligatoirerment avoir 2 chiffres
*   Renvoie false si invalide
*   Renvoie la date formatte jj/mm/aa si valide
********************************************************************************/
function verifDate($date)
{
  if ( !preg_match( '/^([0-9]{2})[.\/-]([0-9]{2})[.\/-]([0-9]{2,4})$/' , $date, $tab) ) {
        return false;
  }
 // if ( $tab[3] == 0 ) { $tab[3] = "2000" ; }
  if ( !checkdate ( $tab[2] , $tab[1] , $tab[3] ) )   {
        return false ;
  }
  $date = $tab[1]."/".$tab[2]."/".$tab[3] ;

  return ( $date ) ;
}

/********************************************************************************
*   Test de la validite d'une heure saisie avec le format :
*       hh:mm
*       le caractre de sparation peut-etre l'espace ou / ou - ou :
*       les valeurs doivent abligatoirerment avoir 2 chiffres
*   Renvoie le tableau des 2 valeurs si valide et false si invalide
********************************************************************************/
function isOkHeure($heure)
{
  	//if ( !ereg( "^([0-9]{2})[:hH ./\-]([0-9]{2})$" , $heure, $tab) ) 
	if ( !preg_match('/^([0-9]{2})[:hH .\/\-]([0-9]{2})$/', $heure, $tab)){
        return false;
	}
  if ( $tab[1] > 23 || $tab[2] > 59 )  {
        return false;
  }

  return $tab  ;
}

/********************************************************************************
*  Formate une date pour stockage YYYY:dd:mm HH:ii:ss &agrave; partir de 
*     - date sous la forme jj/mm/aa (8 ou 10 caractres)
*     - haure sous la forme hh:ii (5 caractres)
*     Le caractre de sparation peut-etre l'espace est idifferent
*     Les valeurs doivent abligatoirerment avoir 2 chiffres
*     La validit n'est pas teste
********************************************************************************/
function formateDateHeureStocke($date,$heure)
	{
	   //Date
      $date=trim($date);
      if ( strlen($date)<8 || strlen($date)>10 ){
         $date='00-00-00';
      } else {
   		// On extrait
   		$jour = substr($date,0,2);
   		$mois = substr($date,3,2);
   		$annee = strlen($date)==10 ? substr($date,6,4) : substr($date,6,2)+2000;
         // renvoi YYYY-mm-jj HH:ii:ss a partir de jj/mm/aa 
   		$date=$annee.'-'.$mois.'-'.$jour   ;
   	}
   	
	   // Heure
      $heure=trim($heure);
      if ( strlen($heure)!=5 ){
         $heure='00:00:00';
      } else {
   		// On extrait
   		$h= substr($heure,0,2);
   		$m = substr($heure,3,2);
         $s='00';
   		$heure=$h.":".$m.":".$s   ;      
      }
   
      // renvoi YYYY-mm-jj HH:ii:ss
		return $date.' '.$heure;
}

/********************************************************************************
* Formate une date de la forme Timestamp et
*    renvoie la date ou l'heure selon le paramtre $p
*    sous la forme JJ/MM/AAAA ($p="")  HH:MM ($p="h")  si $t="" (type standard)
*    sous la forme d'un tableau date ou heure si $t="1"  (pour utilisation directe des valeurs en tableau)
*                            ex : pour calcul sur les dates / heures
********************************************************************************/
/* ANCIENNE FONCTION PEMPLACEE PAR LA SUIVANTE SUITE MODIF FORMAT DES CHAMPS DATE
   de varchar (timesstamp) en DATETIME

function format_date($date , $p="" , $t="")
{
  if ( $date != "" && $date != "0" ) {
     if ( $t == "1" )  {
        $date = getdate( $date ) ;
     }
     else {
        if ( $p == "h" ) {
           $date = gmstrftime ( "%H:%M" , $date ) ;   //original     Pour pb de l'heure n moins (12/12/05)) +3600
          // $date = strftime ( "%H:%M" , $date ) ;
        }
        else {
           $date = gmstrftime ( "%d/%m/%y" , $date ) ;  //original
          // $date = strftime ( "%d/%m/%y" , $date ) ;
        }
     }
  }
  else {  $date = "" ; }
  return ( $date )  ;
}
*/


/********************************************************************************
* Formate une date ou une heure de la forme Y-m-d H:i:s lue dans champs Mysql
*    renvoie la date ou l'heure selon le paramtre $p
*    sous la forme JJ/MM/AA ($p="")  HH:MM ($p="h")  si $t="" (type standard)
*    sous la forme d'un tableau date (si $t=0) ou heure (si $t=1)
*     (pour utilisation directe des valeurs en tableau) ex : pour calcul sur les dates / heures
********************************************************************************/
function format_date($d, $p="" , $t="")
{
  if ( intval($d) != 0 ) {
     if ( $t == "1" )  {
        $date[year]    = substr($d,2,2) ;
        $date[month]   = substr($d,5,2) ;
        $date[mday]    = substr($d,8,2) ;
        $date[hours]   = substr($d,11,2) ;
        $date[minutes] = substr($d,14,2) ;
        $date[seconds] = substr($d,17,2) ;
     }
     else {
        if ( $p == "h" ) {
          // echo "$d :  --> heure : ";
           //$date = substr($date,11,2) . ":" . substr($date,14,2) . ":" . substr($date,17,2) ;
           $date = substr($d,11,2) . ":" . substr($d,14,2);
          // echo "$date<br>";
        }
        else {
           $date = substr($d,8,2) . "/" . substr($d,5,2) . "/" . substr($d,2,2) ;
        }
     }
  }
  else {  $date = "" ; }
  return ( $date )  ;
}

/********************************************************************************
* Formate une date ou une heure de la forme JJ/MM/AA en YY-mm-dd
*    renvoie la date formatte
********************************************************************************/
function formateDateStocke($date)
	{
	   $date=trim($date);
      if ( strlen($date)<8 || strlen($date)>10 ){
         return '';
      }
		
		// On extrait
		$jour = substr($date,0,2);
		$mois = substr($date,3,2);
		$annee = strlen($date)==10 ? substr($date,6,4) : substr($date,6,2)+2000;

      // renvoi YYYY-mm-jj HH:ii:ss a partir de jj/mm/aa 
		return $annee."-".$mois."-".$jour." ".date('H:i:s')   ;
	}

/********************************************************************************
* Formate une date ou une heure de la forme Y-m-d H:i:s lue dans champs Mysql
*    renvoie la date sous la forme February 28th, 2006
********************************************************************************/
function formatDateAnglais($d)
{
  if ( intval($d) != 0 ) {
        $arr['year']    = substr($d,2,2) ;
        $arr['month']   = substr($d,5,2) ;
        $arr['mday']    = substr($d,8,2) ;
        $arr['hours']   = substr($d,11,2) ;
        $arr['minutes'] = substr($d,14,2) ;
        $arr['seconds'] = substr($d,17,2) ;

        $date=date( "F jS, Y", mktime($arr['hours'], $arr['minutes'], $arr['seconds'], $arr['month'], $arr['mday'], $arr['year']));

  }
  else {  $date = "" ; }
  return ( $date )  ;
}


/********************************************************************************
* Vrifie si $date est comprise entre $date1 et $date2
* Les arguments sont passs en timestamp
********************************************************************************/
function date_dans_periode( $date1 , $date2 , $date )
{
  if ( $date >= $date1 AND $date <= $date2 ) {
    return true ;
  }
  else {  return false ; }
}
/********************************************************************************
* renvoie le jour de la semaine en francais  partir d'une date sous la forme timestamp
********************************************************************************/
/* ANCIENNE FONCTION REMPLACEE PAR LA SUIVANTE SUITE MODIF FORMAT DES CHAMPS DATE
   de varchar (timesstamp) en DATETIME

function getJourSem( $date )
{
   $tabjours = array(0=>"Dimanche",1=>"Lundi", 2=>"Mardi",3=>"Mercredi",4=>"Jeudi",5=>"Vendredi",6=>"Samedi");
      return $tabjours[ gmdate("w", $date)  ] ;    //
}
*/
function getJourSem( $str )
{
   $tabjours = array(0=>"Dimanche",1=>"Lundi", 2=>"Mardi",3=>"Mercredi",4=>"Jeudi",5=>"Vendredi",6=>"Samedi");

   $ts = datetimeToTimestamp($str);
   return $tabjours[ date("w", $ts)  ] ;    //
}
/********************************************************************************
*Transforme une date DATETIME mysql (AAAA-MM-JJ hh:mm:ss) en TIMESTAMP
********************************************************************************/
function datetimeToTimestamp($str) {
   $d['year']    = substr($str,2,2) ;
   $d['month']   = substr($str,5,2) ;
   $d['mday']    = substr($str,8,2) ;
   $d['hours']   = substr($str,11,2) ;
   $d['minutes'] = substr($str,14,2) ;
   $d['seconds'] = substr($str,17,2) ; 
   $ts =  mktime ($d['hours'],$d['minutes'],$d['seconds'],$d['month'],$d['mday'],$d['year']);
   return $ts;
}

/********************************************************************************
* remplace virgule par point et supprime les espaces
********************************************************************************/
function format_decim($val) {
    $val = str_replace( "" , "" , $val );
    return str_replace( "," , "." , $val );

}
/********************************************************************************
* FORMATTAGE D'UN NOMBRE
*  - $nul = "n" --> renvoie &nbsp; si 0
*  - $num !="n" --> renvoie 0 si 0
********************************************************************************/
function format_nombre($val, $decim=2, $nul="n") {
    if ( $val=="" || $val ==0 ) {
     // return "&nbsp;";
      return "";
    }
    $val = str_replace( "," , "." , $val );
    return number_format ($val, $decim, ".","") ; ;
}
/********************************************************************************
* ARRONDI
********************************************************************************/
function arrondi($number, $decimals=2, $precision=5)
{
  if (doubleval($number) ==0 ) return 0;
  $precision_add = str_repeat("5",$precision);
  $number = str_replace( "," , "." , $number );
  $number = str_replace( " " , "" , $number );
  if (bccomp($number,0) > 0)
  {
     return (bcadd (bcadd ($number, "0.".str_repeat("0",$decimals).$precision_add, $decimals+$precision), 0, $decimals));
  }
  else
  {
     return (bcadd (bcsub ($number, "0.".str_repeat("0",$decimals).$precision_add, $decimals+$precision), 0, $decimals));
  }
}
/********************************************************************************
* Suppression des caractres de controles parasites pour enreg dans un fichier texte
********************************************************************************/
function cleanParasites($str) {
     for ( $i = 1 ; $i < 32 ; $i++ ) {
        $str = str_replace( chr($i) , " ", $str) ;
     }
     $str = str_replace( "#" , " ", $str) ;
     //$str = str_replace( "'" , "\'", $str) ;
     return $str ;
}
/********************************************************************************
* Affichage du contenu d'une variable si existe sinon affichage &nbsp;
********************************************************************************/
function afficheSiExiste($str) {
    if ( empty($str) ) {
        return "&nbsp;" ;
    }
    else {
        return $str ;
    }
}
/********************************************************************************
* Preparation du contenu d'une variable pour affichage tronqu
* si la longueur de la chaine dpasse la valur $lg
********************************************************************************/
function set_col($str, $lg) { 
  $lg == "" ? $lg = strlen($str) : nul();
  if ($str!="" && strlen($str) > $lg ) {
     $str1 = substr ( $str, 0 ,$lg) ; 
     $str1 = '<span title="'.$str.'">'.$str1.'...</span>' ;
     //$str1 = '<a href="javascript:" id="suite" title="'.$str.'">'.$str1.'...</a>' ;
  }
  else {
     $str1 = $str ;
  }
  
  return $str1;
}

/*************************************************
* Formatage d'une chaine en compltant
*  avec un caractre donn en debut (0)
*************************************************/
function pre_fill ( $string , $size , $car="0" )   {
    $string = sprintf ("%'0".$size.".".$size."s",$string) ;
    return $string ;
}
/********************************************************************************
* Affichage d'un message pour les scripts ne faisant aucune sortie cran
* mais redirigent directement par HEADER ( );
* --> Il faut donc afficher header et footer
********************************************************************************/
function Affiche_mes( $mes ) {
     include ( "./header.php") ;
     ?>
       <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">
         <tr>
           <td align="center">
             <?php echo $mes ; ?>
           </td>
         </tr>
       </table>
     <?php
     include ("./footer.php") ;
}

function Affiche_mes_seul( $mes ) {

     ?>
       <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">
         <tr>
           <td align="center">
             <?php echo $mes ; ?>
           </td>
         </tr>
       </table>
     <?php

}
?>