<?php
/*
 * ps_html Class
 *
 * Copyright (c) Edikon Corporation.  All rights reserved.
 * Distributed under the phpShop Public License (pSPL) Version 1.0.
 *
 * $Id: pr_html.inc,v 1.4 2000/10/21 06:48:02 reallost1 Exp $
 *   Modified 2001/09 Ph Ripond   --> pr_html
 */

class pr_html {
  var $classname = "pr_html";
  var $refart ;
  /**************************************************************************
  ** name: dropdown_display()
  ** created by: gday
  ** modify ph Ripond 10/2001
  ** description:  Print an HTML dropdown box named $name using $arr to
  **               load the drop down.  If $value is in $arr, then $value
  **               will be the selected option in the dropdown.
  ** parameters: $name - name of the HTML dropdown element
  **             $value - Drop down item to make selected
  **             $values - array use to set (if exist) the value of the input
  **                         instead of the $val from $arr
  **             $arr - array used to build the HTML drop down element
  ** returns: prints HTML drop down element to standard output
  ***************************************************************************/
   function dropdown_display($name, $value, $arr, $values="" , $style="", $tabindex="", $lg="50" ) {
      $style !="" ?  $class = " class=\"$style\"" : $class = "" ;
      $tabindex !=""  ? $tabindex = " tabindex=\"$tabindex\""  : $tabindex = "";

      echo "<SELECT NAME=\"$name\" SIZE=\"1\"".$class."$tabindex>\n";
      echo "<OPTION VALUE=\"\"> - </OPTION>\n";
       while (list($key, $val) = each($arr)) {
           if ( $values[$key] == "" )  {
               $v = $key ;
           }
           elseif ( $values == "indice")  {
               $v = $key ;
           }
           else  {
               $v = $values[$key] ;
           }
           if ( strlen($val) > $lg ) {
              $val = substr($val , 0, $lg);
           }
           if(strcmp($value, $v ) == 0) {
                echo "<OPTION VALUE=\"$v\" SELECTED>$val</option>\n";
           }
           else {
                echo "<OPTION VALUE=\"$v\">$val</option>\n";
           }
        }
      echo "</SELECT>\n";

      return True;
   }

  /**************************************************************************
  ** name: list_year($list_name)
  ** created by: pfmartin
  ** description:  Print an HTML dropdown box for classement
  ** parameters: $name - name of the HTML dropdown element
  **             $val - Drop down item to make selected
  **             $type - name of the class to use in the SELECT tag
  ** returns: prints HTML drop down element to standard output
  ***************************************************************************/
   function list_class( $name, $val, $style="" ) {
      $class = "" ;
      if ( $style !="" ) {
         $class = " class=\"$style\"" ;
      }
      echo "<SELECT NAME=\"$name\" SIZE=\"1\"".$class.">\n";
      echo "<OPTION VALUE=\"\"> - </OPTION>\n";
      for ( $i = 1 ; $i <= 10 ; $i++ ) {
         if( $i == $val ) {
            echo "<OPTION VALUE=\"$i\" SELECTED>$i\n";
         }
         else {
            echo "<OPTION VALUE=\"$i\">$i\n";
         }
      }
      echo "</SELECT>\n";
      return 1;
   }
  /**************************************************************************
  ** name: radiochek_display($name,$value,$type)
  ** created by: phripond
  ** description:  Print an HTML checkbox with checked attribut if $value = "o"
  ** parameters: $name : name of the HTML checkbox /radio element
  **             $value : current value of the field ( o/n )
  **             $type  : input type : checkbox / radio
  ** returns: prints HTML checkbox / radio element to standard output
  ** ****************** WARNING : doesn't work with radio *************
  ***************************************************************************/
  function  radiocheck_display( $name, $value, $type="checkbox" ) {
        if ( $value == "o" ) {
           $ck="checked";
        }
        else {
           $ck="";
        }
     echo "<input type=\"$type\" name=\"$name\" value=\"o\" ".$ck."  />\n" ;
  }

} // Fin classe

?>