<?php
include ("./config.inc.php") ;

/*********************************************************
*  Impression d'une facture avec la classe FPDF
*  implementation de la classe
**********************************************************/
define('FPDF_FONTPATH', DIR_COMMON.'font/');
require(DIR_COMMON.'fpdf.php');

/*********************************************************
*  Verification session
**********************************************************/
  $connected = false ;
  if( $PHPSESSID )  {
      if(!isset($_SESSION)){
			session_start($PHPSESSID) ;
		}
      if ( $usr_droits == "admin" || $usr_droits == "user" )  {
         $connected = true ;
      }
  }
  if ( !$connected ) {
      header("location: index.php" ) ;
	  exit();
  }
/************************************/

// Variables
//GET
$id_escale = $HTTP_GET_VARS["id_escale"] ;

/*********************************************************
*  DATE
**********************************************************/
//fonction de modification de date (le jj mois yyyy)

function newdate($fdate=""){ //un tableau de mois.
	$tabMois=array("01"=>"janvier","02"=>"fvrier","03"=>"mars","04"=>"avril","05"=>"mai","06"=>"juin","07"=>"juillet","08"=>"aot","09"=>"septembre","10"=>"octobre","11"=>"novembre","12"=>"dcembre");
    
	$jour=substr($fdate,0,2);
    substr($fdate,0,2) == "01" ? $jour="1er" : $jour=substr($fdate,0,2);
    $mois=$tabMois[substr($fdate,3,2)];
    $annee=substr($fdate,6,2);
	$ladate=$jour." ".$mois." 20".$annee;
	return $ladate;
}

/*********************************************************
*  Include
**********************************************************/
include ( DIR_COMMON ."debut.php") ;
include ( DIR_COMMON . "cl_escale.php") ;
$escale = new escale( $id_escale, $cnx->id ) ;


/******************************************************
*  Lecture de l'enregistrement
*  Affectation des variables
******************************************************/

/*********************************************************
*  Creation du document
**********************************************************/
  // initialisation pied de page

  $pdf_font="Times"; // Times, helvetica

  class PDFF extends FPDF {

    function Footer() {

      global $escale;

      //Positionnement  1.5 cm du bas
      $this->SetY(-15);
      // Coordonnes et date
      $this->SetFont($pdf_font,'',8);
      $this->SetXY(10,280) ;
      $this->Cell(190,3,"Marship - Commentaires de l'escale ".$escale->num."  -  Edit le ".date("d/m/y"),0,1,'C');
    }
  }

  $pdf = new PDFF();
  $pdf->Open();
  $pdf->AddPage();
  // initialisation distance minin de saut de page
  $pdf->SetAutoPageBreak( true, 18 );

/*********************************************************
*  Adresse Marship
**********************************************************/

$x = 10;
$y = 10;

$pdf->SetFont('Times','',12);

$pdf->SetXY($x,$y) ;

if ( $usr_site == "Guadeloupe" ) {

   $pdf->MultiCell(120,5,"- CAMARSHIP -",0,'L');

   $pdf->MultiCell(120,5,"Centre Saint John Perse\nQuai Ferdinand Lesseps n8",0,'L');

   $pdf->Cell(120,5,"97110 POINTE  PITRE",0,2,'L');

   

} elseif ( $usr_site == "Martinique" ) {

   $pdf->MultiCell(120,5,"MARSHIP",0,'L');

   $pdf->MultiCell(120,5,"Immeuble du Port\nAvenue Franois Mitterrand ",0,'L');

   $pdf->Cell(120,5,"97200 FORT DE FRANCE",0,2,'L');

   

} elseif ( $usr_site == "Oss97" ) {

   $pdf->MultiCell(120,5,"OSS97",0,'L');

   $pdf->MultiCell(120,5,"Immeuble du Port\nAvenue Franois Mitterrand ",0,'L');

   $pdf->Cell(120,5,"97200 FORT DE FRANCE",0,2,'L'); 

   

} elseif ( $usr_site == "Oss97_guad" ) {

   $pdf->MultiCell(120,5,"OSS97",0,'L');

   $pdf->MultiCell(120,5,"Immeuble du Port\nAvenue Franois Mitterrand ",0,'L');

   $pdf->Cell(120,5,"97200 FORT DE FRANCE",0,2,'L');

/*Start HP for Agency*/
}elseif (  $usr_site == "antilles_guad" )  {
   $pdf->MultiCell(120,5,"Antilles Shipping Guadeloupe",0,'L');

   $pdf->MultiCell(120,5,"Immeuble du Port\nAvenue Franois Mitterrand",0,'L');

   $pdf->Cell(120,5,"97200 FORT DE FRANCE",0,2,'L');

/*End HP for Agency*/   

} else {

   $pdf->MultiCell(120,5,"ANTILLES SHIPPING",0,'L');

   $pdf->MultiCell(120,5,"Immeuble du Port\nAvenue Franois Mitterrand",0,'L');

   $pdf->Cell(120,5,"97200 FORT DE FRANCE",0,2,'L');

}

/*********************************************************
*  TITRE
**********************************************************/

$y = $pdf->GetY() + 10;

$pdf->SetFont('Times','B',20);

$pdf->SetXY($x,$y) ;

$pdf->Cell(180,5,"Commentaires d'escale",0,0,'C');

/*********************************************************
*  Rfrences escale
**********************************************************/

$y = $pdf->GetY() + 15;

// cadre

$pdf->Rect($x-2, $y-2, 190, 23 );



$pdf->SetFont('Times','',11);

$pdf->SetXY($x,$y) ;

$pdf->Cell(130,5,"M/V : ".$escale->bateau_nom,0,0,'L');

$pdf->Cell(50,5,"Dossier n : ".$escale->num,0,0,'L');

$y = $pdf->GetY() + 5;

$pdf->SetXY($x,$y) ;

$pdf->Cell(70,5,"Quai : ".$escale->quai1_nom,0,0,'L');

$y = $pdf->GetY() + 5;

$pdf->SetXY($x,$y) ;

$pdf->Cell(75,5,"Date d'arrive  : ".$escale->arr_jour." ".format_date($escale->arrivee)."  ".format_date($escale->arrivee,"h"),0,0,'L');

$pdf->Cell(40,5,"Fri/Samedi/Dimanche : ",0,0,'L');

$escale->arr_ferie != "o" && $escale->arr_precis == "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;

$xx = $pdf->GetX()+ 5;

$pdf->SetXY($xx,$y) ;

$pdf->Cell(10,5," Non",0,0,'L');

$escale->arr_ferie == "o" || $escale->arr_precis != "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;

$xx = $pdf->GetX()+ 5;

$pdf->SetXY($xx,$y) ;

$pdf->Cell(70,5,"Oui : ".$escale->arr_precis,0,0,'L');



$y = $pdf->GetY() + 5;

$pdf->SetXY($x,$y) ;

$pdf->Cell(75,5,"Date de dpart : ".$escale->dep_jour." ".format_date($escale->depart)."  ".format_date($escale->depart,"h"),0,0,'L');

$pdf->Cell(40,5,"Fri/Samedi/Dimanche : ",0,0,'L');

$escale->dep_ferie != "o" && $escale->dep_precis == "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;

$xx = $pdf->GetX()+ 5;

$pdf->SetXY($xx,$y) ;

$pdf->Cell(10,5," Non",0,0,'L');

$escale->dep_ferie == "o" || $escale->dep_precis != "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;

$xx = $pdf->GetX()+ 5;

$pdf->SetXY($xx,$y) ;

$pdf->Cell(70,5,"Oui : ".$escale->dep_precis,0,0,'L');



$y = $pdf->GetY() + 5;

$pdf->SetXY($x,$y) ;


/*********************************************************
*  Formulaire
**********************************************************/


$xx = $pdf->GetX()+ 5;
$y = $pdf->GetY();
$pdf->SetXY($x,$y) ;
$pdf->SetFont('Times','B',15);
$pdf->Cell(60,20, 'Commentaires' ,0,2,'L');

$xx = $pdf->GetX()+ 5;
$y = $pdf->GetY()-5;
$pdf->SetXY($x,$y) ;
$pdf->SetFont('Times','',10);
$pdf->MultiCell(195,4,iconv('UTF-8', 'windows-1252', strip_tags(html_entity_decode($escale->com))),0,'L');
//$pdf->MultiCell(195,4,iconv('UTF-8', 'windows-1252', html_entity_decode($escale->com)),0,'L');

$xx = $pdf->GetX()+ 5;
$y = $pdf->GetY();
$pdf->SetXY($x,$y) ;
$pdf->SetFont('Times','B',15);
$pdf->Cell(60,20, 'Commentaires (Accounting)' ,0,2,'L');

$xx = $pdf->GetX()+ 5;
$y = $pdf->GetY()-5;
$pdf->SetXY($x,$y) ;
$pdf->SetFont('Times','',10);
$pdf->MultiCell(195,4,iconv('UTF-8', 'windows-1252', strip_tags(html_entity_decode($escale->com_accounting))),0,'L');

/*********************************************************
*  Affichage
**********************************************************/

  $pdf->SetDisplayMode('fullwidth');

  $pdf->Output();


/*********************************************************
*  Fonctions
**********************************************************/

function boxUnchecked($x, $y) {

  global $pdf;

  $y = $y+1;

  $pdf->Rect($x, $y, 3, 3 );

}

function boxChecked($x, $y) {

  global $pdf;

  $y = $y+1;

  $pdf->Rect($x, $y, 3, 3 );

  $pdf->Line($x+0.05, $y+0.05, $x+2.95, $y+2.95 );

  $pdf->Line($x+0.05, $y+2.95, $x+2.95, $y+0.05 );

}
?>