<?php
include ("./config.inc.php") ;
/*********************************************************
*  Impression d'une facture avec la classe FPDF
*  implementation de la classe
**********************************************************/
define('FPDF_FONTPATH', DIR_COMMON.'font/');
require(DIR_COMMON.'fpdf.php');

/*********************************************************
*  Verification session
**********************************************************/
  $connected = false ;
  if( $PHPSESSID )  {
      if(!isset($_SESSION)){
			session_start($PHPSESSID) ;
		}
      if ( $usr_droits == "admin" || $usr_droits == "user" )  {
         $connected = true ;
      }
  }
  if ( !$connected ) {
      header("location: index.php" ) ;
  }
/************************************/
// Variables
//GET
$id_escale = $HTTP_GET_VARS["id_escale"] ;

/*********************************************************
*  DATE
**********************************************************/
//fonction de modification de date (le jj mois yyyy)
function newdate($fdate=""){
//un tableau de mois.
$tabMois=array("01"=>"janvier","02"=>"fvrier","03"=>"mars","04"=>"avril","05"=>"mai","06"=>"juin","07"=>"juillet","08"=>"aot","09"=>"septembre","10"=>"octobre","11"=>"novembre","12"=>"dcembre");
        $jour=substr($fdate,0,2);
        substr($fdate,0,2) == "01" ? $jour="1er" : $jour=substr($fdate,0,2);
        $mois=$tabMois[substr($fdate,3,2)];
        $annee=substr($fdate,6,2);
        $ladate=$jour." ".$mois." 20".$annee;
        return $ladate;
}

/*********************************************************
*  Include
**********************************************************/
include ( DIR_COMMON ."debut.php") ;

include ( DIR_COMMON . "cl_cr.php") ;
$cr     = new cr( $id_escale, $cnx->id ) ;

include ( DIR_COMMON . "cl_escale.php") ;
$escale = new escale( $id_escale, $cnx->id ) ;

// Lecture du modele de compte rendu
include ( DIR_COMMON . "cr_escales".$cr->modele.".php") ;


/******************************************************
*  Lecture de l'enregistrement
*  Affectation des variables
******************************************************/
// recherche si CR existe pour cette escale
if ( $cr->id != "" ) {
       $cr->affecteReponses();
}
else {
    echo "Compte-rendu de l'escale ".$escale->num." inexistant" ;
    exit();
}

/*********************************************************
*  Creation du document
**********************************************************/
  // initialisation pied de page
  class PDF extends FPDF {
    function Footer() {
      global $escale;
      //Positionnement  1.5 cm du bas
      $this->SetY(-15);
      // Coordonnes et date
      $this->SetFont('Arial','',8);
      $this->SetXY(10,280) ;
      $this->Cell(190,3,"Marship - Compte-rendu de l'escale ".$escale->num."  -  Edit le ".date("d/m/y"),0,1,'C');
    }
  }

  $pdf = new PDF();

  $pdf->Open();

  $pdf->AddPage();

  // initialisation distance minin de saut de page
  $pdf->SetAutoPageBreak( true, 10 ) ;

/*********************************************************
*  Adresse Marship
**********************************************************/
$x = 10;
$y = 10;
$pdf->SetFont('Times','',12);
$pdf->SetXY($x,$y) ;
if ( $usr_site == "Guadeloupe" ) {
   $pdf->MultiCell(120,5,"- CAMARSHIP -",0,'L');
   $pdf->MultiCell(120,5,"Centre Saint John Perse\nQuai Ferdinand Lesseps n8",0,'L');
   $pdf->Cell(120,5,"97110 POINTE  PITRE",0,2,'L');
} else {
   $pdf->MultiCell(120,5,"MARSHIP",0,'L');
   $pdf->MultiCell(120,5,"Immeuble du Port\nAvenue Franois Mitterrand",0,'L');
   $pdf->Cell(120,5,"97200 FORT DE FRANCE",0,2,'L');
}

/*********************************************************
*  TITRE
**********************************************************/
$y = $pdf->GetY() + 10;
$pdf->SetFont('Times','B',20);
$pdf->SetXY($x,$y) ;
$pdf->Cell(180,5,"Compte-rendu d'escale",0,0,'C');
/*********************************************************
*  Rfrences escale
**********************************************************/
$y = $pdf->GetY() + 15;
// cadre
$pdf->Rect($x-2, $y-2, 190, 23 );

$pdf->SetFont('Times','',11);
$pdf->SetXY($x,$y) ;
$pdf->Cell(130,5,"M/V : ".$escale->bateau_nom,0,0,'L');
$pdf->Cell(50,5,"Dossier n : ".$escale->num,0,0,'L');
$y = $pdf->GetY() + 5;
$pdf->SetXY($x,$y) ;
$pdf->Cell(70,5,"Quai : ".$escale->quai1_nom,0,0,'L');
$y = $pdf->GetY() + 5;
$pdf->SetXY($x,$y) ;
$pdf->Cell(75,5,"Date d'arrive  : ".$escale->arr_jour." ".format_date($escale->arrivee)."  ".format_date($escale->arrivee,"h"),0,0,'L');
$pdf->Cell(40,5,"Fri/Samedi/Dimanche : ",0,0,'L');
$escale->arr_ferie != "o" && $escale->arr_precis == "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
$xx = $pdf->GetX()+ 5;
$pdf->SetXY($xx,$y) ;
$pdf->Cell(10,5," Non",0,0,'L');
$escale->arr_ferie == "o" || $escale->arr_precis != "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
$xx = $pdf->GetX()+ 5;
$pdf->SetXY($xx,$y) ;
$pdf->Cell(70,5,"Oui : ".$escale->arr_precis,0,0,'L');

$y = $pdf->GetY() + 5;
$pdf->SetXY($x,$y) ;
$pdf->Cell(75,5,"Date de dpart : ".$escale->dep_jour." ".format_date($escale->depart)."  ".format_date($escale->depart,"h"),0,0,'L');
$pdf->Cell(40,5,"Fri/Samedi/Dimanche : ",0,0,'L');
$escale->dep_ferie != "o" && $escale->dep_precis == "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
$xx = $pdf->GetX()+ 5;
$pdf->SetXY($xx,$y) ;
$pdf->Cell(10,5," Non",0,0,'L');
$escale->dep_ferie == "o" || $escale->dep_precis != "" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
$xx = $pdf->GetX()+ 5;
$pdf->SetXY($xx,$y) ;
$pdf->Cell(70,5,"Oui : ".$escale->dep_precis,0,0,'L');

$y = $pdf->GetY() + 5;
$pdf->SetXY($x,$y) ;


/*********************************************************
*  Formulaire
**********************************************************/
$x = 10 ;
$y = $pdf->GetY() +15 ;
$h = 6 ;
$pdf->SetFillColor(240,240,240) ;  // couleur de fond
$fond  = 0;    // paramtre d'arriere plan des rponses texte existantes
$forme = 'B';  // paramtre de mise en forme des rponses texte existantes

for ( $c=0; $c<count($categ); $c++ )  {
// Boucle sur les catgories de dpenses (Port Charges, Vessel expenses, ...)
    if ( $c == 2 || $c == 3 ) {
       $pdf->AddPage();
       $x = 10 ;
       $y = 10 ;
    }
    $pdf->SetXY($x,$y) ;
    $pdf->SetFont('Times','B',13);
    $pdf->Cell(60,10, ($c+1)." / ".$categ[$c] ,0,2,'L');

    for ( $l=0; $l<count($l_lib[$c]); $l++ )  {
    // Boucle sur les lignes
        $pdf->SetFont('Times','',11);
        $pdf->Cell(30,$h, $l_lib[$c][$l][0] ,0,0,'L');
      if ( $l_rep_typ[$c][$l][0] != 'soustitre' ) {  
        $pdf->Cell(3,$h, " : " ,0,0,'L');

        $y = $pdf->GetY();
        $cr->rep[$c][$l][0] == "n" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
        $pdf->SetXY($pdf->GetX()+ $h,$y) ;
        $pdf->Cell(8,$h,"Non",0,0,'L');
        $cr->rep[$c][$l][0] == "o" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
        $pdf->SetXY($pdf->GetX()+ $h,$y) ;
        $pdf->Cell(8,$h,"Oui",0,0,'L');
        $decal = 70 ; // correspond au libel depense + non / oui
      }
        for ( $i=1; $i<count($l_lib[$c][$l]); $i++ )  {
        // Boucle sur les rponses
             $lg = $pdf->GetStringWidth($l_lib[$c][$l][$i]) ;
             $pdf->Cell($lg,$h, $l_lib[$c][$l][$i] ,0,0,'L');
             $type = $l_rep_typ[$c][$l][$i] ;
             // prparation mise en forme des rponses non vides
             if ( $cr->rep[$c][$l][$i] != '' ) {
               $p1=$fond ; 
               $p2=$forme;
             } else {
               $p1=0;
               $p2='';
             }
             switch ($type)  {
                case "o/n" :
                   $y = $pdf->GetY();
                   $cr->rep[$c][$l][$i] == "n" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
                   $pdf->SetXY($pdf->GetX()+ $h,$y) ;
                   $pdf->Cell(8,$h,"Non",0,0,'L');
                   $cr->rep[$c][$l][$i] == "o" ? boxChecked($pdf->getX() + 2, $y) : boxUnchecked($pdf->getX() + 2, $y) ;
                   $pdf->SetXY($pdf->GetX()+ $h,$y) ;
                   $pdf->Cell(8,$h,"Oui",0,0,'L');
                break;

                case "textarea":
                   $pdf->SetFont('Times',$p2,11);
                   $pdf->SetXY($x+$decal,$pdf->GetY()+$h) ;
                   $pdf->MultiCell(80,$h, $cr->rep[$c][$l][$i] ,0,'L',$p1);
                   $pdf->SetFont('Times','',11);
                break;

                default:
                   $pdf->SetFont('Times',$p2,11);
                   $lg = floor($l_rep_lg[$c][$l][$i] * 3.5  ) ; //
                   $pdf->Cell($lg,$h, $cr->rep[$c][$l][$i] ,0,0,'L',$p1);
                   $pdf->SetFont('Times','',11);
                   //$pdf->SetXY($pdf->GetX(),$pdf->GetY()) ;
                   //$pdf->MultiCell($lg,$h, $cr->rep[$c][$l][$i] ,1,'L');
             }
             if ( $l_rep_cr[$c][$l][$i] == "<br />" )  {
                // Saut de ligne aprs la rponse si demand
                $pdf->SetXY($x+$decal,$pdf->GetY()+$h) ;
             }
        }    // Fin boucle sur les reponses
      $pdf->SetXY($x, ($pdf->GetY()+$h) ) ;
    }  // Fin boucle sur les lignes
    $y = $pdf->GetY() + $h ;
} // fin boucle sur categ


/*********************************************************
*  Affichage
**********************************************************/
  $pdf->SetDisplayMode('fullwidth');
  $pdf->Output();

/*********************************************************
*  Fonctions
**********************************************************/
function boxUnchecked($x, $y) {
  global $pdf;
  $y = $y+1;
  $pdf->Rect($x, $y, 3, 3 );
}

function boxChecked($x, $y) {
  global $pdf;
  $y = $y+1;
  $pdf->Rect($x, $y, 3, 3 );
  $pdf->Line($x+0.05, $y+0.05, $x+2.95, $y+2.95 );
  $pdf->Line($x+0.05, $y+2.95, $x+2.95, $y+0.05 );
}

?>